package earth.krakatao;

import earth.krakatao.events.KraSocketClientEventInitiater;
import earth.krakatao.events.KraSocketClientEventInterface;
import earth.krakatao.protocol.KraSocketClientProtocol;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.logging.Logger;
import lombok.Getter;

public class KraSocketClient {

  @Getter
  public static final Logger logger = Logger.getLogger("KraSocketClient");

  private KraSocketClientConfig kraSocketClientConfig;
  @Getter
  private final SocketClient socketClient;
  private KraSocketClientEventInitiater kraSocketClientEventInitiater;

  public KraSocketClient(KraSocketClientConfig kraSocketClientConfig,
      KraSocketClientEventInterface kraSocketClientEventInterface,
      KraSocketClientProtocol kraSocketClientProtocol)
      throws URISyntaxException {
    this.kraSocketClientConfig = kraSocketClientConfig;

    this.kraSocketClientEventInitiater = new KraSocketClientEventInitiater();
    this.kraSocketClientEventInitiater.addListener(kraSocketClientEventInterface);

    this.socketClient = new SocketClient(new URI(this.kraSocketClientConfig.getWebSocketProtocol()
        + "://" + this.kraSocketClientConfig.getWebSocketHost() + ":"
        + this.kraSocketClientConfig.getWebSocketPort()
        + "/ws?ak=" + this.kraSocketClientConfig.getWebSocketAccessKey()
        + "&s=" + this.kraSocketClientConfig.getWebSocketServerName()),
        this.kraSocketClientEventInitiater, kraSocketClientProtocol,
        this.kraSocketClientConfig.getWebSocketAckTimeouts());
  }
}